import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PushbackReader;


public class JackTokenizer {

	
	private PushbackReader reader;
	private boolean hasMoreTokens;
	private char ch;
	private TokenType tokenType;
	private KeyWord keyWord;
	private char symbol;
	private String identifier;


	public JackTokenizer(File src) {
		hasMoreTokens = true;

		try {
			reader = new PushbackReader(new FileReader(src));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(1);
		}	
	}

	public boolean hasMoreTokens() {
		return hasMoreTokens;
	}
	
	public TokenType tokenType(){
		return tokenType;
	}
	
	public KeyWord keyWord(){
		return keyWord;
	}
	
	public char symbol(){
		return symbol;
	}
	
	public String identifier(){
		return identifier;
	}
	
	public int intVal(){
		try{
			return Integer.parseInt(identifier);
		}catch (NumberFormatException e){
			e.printStackTrace();
			System.exit(1);
		}
		return -1;
	}
	
	// Return string without the enclosing quotes.
	public String stringVal(){
		return identifier;
	}
	
	private void getNextChar(){
		try{
			int data = reader.read();
			if (data == -1)
				hasMoreTokens = false;
			else
				ch = (char)data;
		} catch(IOException e){
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private void unread(){
		try{
			reader.unread(ch);
		} catch(IOException e){
			e.printStackTrace();
			System.exit(1);
		}
	}
		

	public void advance() {
		// Complete to advance over next token, setting values in the fields
		
	}


}
